Bug 1109490 - Review Request: alglib - A numerical analysis and data processing library
Summary: Review Request: alglib - A numerical analysis and data processing library
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Antonio Trande
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: 753577 1111388
TreeView+ depends on / blocked
 
Reported: 2014-06-14 13:24 UTC by Sandro Mani
Modified: 2015-01-17 19:17 UTC (History)
4 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2014-07-19 06:04:19 UTC
anto.trande: fedora-review+
kevin: fedora-cvs+


Attachments (Terms of Use)
Exclusive for primary archs (1.15 KB, patch)
2014-07-09 09:53 UTC, Jakub Čajka
no flags Details | Diff

Description Sandro Mani 2014-06-14 13:24:35 UTC
Spec URL: http://smani.fedorapeople.org/review/alglib.spec
SRPM URL: http://smani.fedorapeople.org/review/alglib-3.8.2-1.fc21.src.rpm
Description: A numerical analysis and data processing library
Fedora Account System Username: smani

Comment 1 Antonio Trande 2014-06-14 14:38:51 UTC
Hi Sandro.

Review swap with https://bugzilla.redhat.com/show_bug.cgi?id=1105730?

Comment 2 Sandro Mani 2014-06-14 14:42:16 UTC
Sure. Maybe hold off the posting the review for a day or so until Alexey Vasyukov has had a chance to do an informal review, so that he has some reviews to show off for him to get sponsored, see [1].

[1] https://bugzilla.redhat.com/show_bug.cgi?id=1065541#c10

Comment 3 Antonio Trande 2014-06-14 14:48:56 UTC
(In reply to Sandro Mani from comment #2)
> Sure. Maybe hold off the posting the review for a day or so until Alexey
> Vasyukov has had a chance to do an informal review, so that he has some
> reviews to show off for him to get sponsored, see [1].
> 
> [1] https://bugzilla.redhat.com/show_bug.cgi?id=1065541#c10

Okay, wait for a review by Alexey then I will do mine.

Comment 4 Antonio Trande 2014-06-17 21:22:26 UTC
- Documentation html file is released under BSD license (its License text file is missing).
  Better if packaged as -doc sub-package.

- Please, fix all warnings/errors from rpmlint.

- alglib seems to provide two tests too.
  See http://www.alglib.net/translator/man/manual.cpp.html#gs_testing

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Development (unversioned) .so files in -devel subpackage, if present.
  Note: Unversioned so-files directly in %_libdir.
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#DevelPackages
- Large documentation must go in a -doc subpackage. Large could be size (~1MB)
  or number of files.
  Note: Documentation size is 1761280 bytes in 2 files.
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#PackageDocumentation


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (v2 or later)", "Unknown or generated". 4 files have unknown
     license. Detailed output of licensecheck in
     /home/sagitter/1109490-alglib/licensecheck.txt
[!]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[!]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[!]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[!]: Final provides and requires are sane (see attachments).
[ ]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[?]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
     Note: Arch-ed rpms have a total of 1761280 bytes in /usr/share
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: alglib-3.8.2-1.fc21.i686.rpm
          alglib-devel-3.8.2-1.fc21.i686.rpm
          alglib-3.8.2-1.fc21.src.rpm
alglib.i686: W: spurious-executable-perm /usr/share/doc/alglib/manual.cpp.html
alglib.i686: E: wrong-script-end-of-line-encoding /usr/share/doc/alglib/manual.cpp.html
alglib.i686: W: spurious-executable-perm /usr/share/doc/alglib/gpl2.txt
alglib.i686: W: devel-file-in-non-devel-package /usr/lib/libalglib.so
alglib-devel.i686: W: no-documentation
3 packages and 0 specfiles checked; 1 errors, 4 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint alglib alglib-devel
alglib.i686: W: spurious-executable-perm /usr/share/doc/alglib/manual.cpp.html
alglib.i686: E: wrong-script-end-of-line-encoding /usr/share/doc/alglib/manual.cpp.html
alglib.i686: W: spurious-executable-perm /usr/share/doc/alglib/gpl2.txt
alglib.i686: W: devel-file-in-non-devel-package /usr/lib/libalglib.so
alglib-devel.i686: W: no-documentation
2 packages and 0 specfiles checked; 1 errors, 4 warnings.
# echo 'rpmlint-done:'



Requires
--------
alglib (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libalglib.so.3
    libc.so.6
    libgcc_s.so.1
    libgcc_s.so.1(GCC_3.0)
    libm.so.6
    libstdc++.so.6
    libstdc++.so.6(CXXABI_1.3)
    rtld(GNU_HASH)

alglib-devel (rpmlib, GLIBC filtered):
    alglib(x86-32)
    libalglib.so.3



Provides
--------
alglib:
    alglib
    alglib(x86-32)
    libalglib.so.3

alglib-devel:
    alglib-devel
    alglib-devel(x86-32)



Unversioned so-files
--------------------
alglib: /usr/lib/libalglib.so

Source checksums
----------------
http://www.alglib.net/translator/re/alglib-3.8.2.cpp.tgz :
  CHECKSUM(SHA256) this package     : c02944558849c8b22f32f8dea03ebf3b77a0aab9aa2518927d25f6bfe7cb06a2
  CHECKSUM(SHA256) upstream package : c02944558849c8b22f32f8dea03ebf3b77a0aab9aa2518927d25f6bfe7cb06a2


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -m fedora-rawhide-i386 -b 1109490
Buildroot used: fedora-rawhide-i386
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 5 Sandro Mani 2014-06-18 19:00:01 UTC
Spec URL: http://smani.fedorapeople.org/review/alglib.spec
SRPM URL: http://smani.fedorapeople.org/review/alglib-3.8.2-2.fc21.src.rpm

%changelog
* Wed Jun 18 2014 Sandro Mani <manisandro@gmail.com> - 3.8.2-2
- Add doc subpackage with correct license
- Run tests
- Fix unversioned so included in main package
- Fix manual.cpp.html permissions, line endings

Comment 6 Antonio Trande 2014-06-18 19:53:46 UTC
License file (BSD) is missing and not tagged for -doc package.

Comment 7 Sandro Mani 2014-06-18 20:18:17 UTC
Spec URL: http://smani.fedorapeople.org/review/alglib.spec
SRPM URL: http://smani.fedorapeople.org/review/alglib-3.8.2-3.fc21.src.rpm

%changelog
* Wed Jun 18 2014 Sandro Mani <manisandro@gmail.com> - 3.8.2-3
- Add bsd.txt to doc subpackage (license text extracted from manual.cpp.html)

Comment 8 Antonio Trande 2014-06-18 20:26:59 UTC
-doc needs an own License tag:

%package        doc
Summary:        API documentation for %{name}
BuildArch:      noarch
License:        BSD
%description    doc
The %{name}-doc package contains the %{name} API documentation.

http://fedoraproject.org/wiki/Packaging:LicensingGuidelines#License:_field

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[-]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (v2 or later)", "Unknown or generated". 4 files have unknown
     license. Detailed output of licensecheck in
     /home/sagitter/1109490-alglib/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[-]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in alglib-doc
[ ]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: alglib-3.8.2-2.fc21.i686.rpm
          alglib-devel-3.8.2-2.fc21.i686.rpm
          alglib-doc-3.8.2-2.fc21.noarch.rpm
          alglib-3.8.2-2.fc21.src.rpm
alglib-devel.i686: W: no-documentation
4 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint alglib-doc alglib alglib-devel
alglib-devel.i686: W: no-documentation
3 packages and 0 specfiles checked; 0 errors, 1 warnings.
# echo 'rpmlint-done:'



Requires
--------
alglib-doc (rpmlib, GLIBC filtered):

alglib (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6
    libgcc_s.so.1
    libgcc_s.so.1(GCC_3.0)
    libm.so.6
    libstdc++.so.6
    libstdc++.so.6(CXXABI_1.3)
    rtld(GNU_HASH)

alglib-devel (rpmlib, GLIBC filtered):
    alglib(x86-32)
    libalglib.so.3



Provides
--------
alglib-doc:
    alglib-doc

alglib:
    alglib
    alglib(x86-32)
    libalglib.so.3

alglib-devel:
    alglib-devel
    alglib-devel(x86-32)



Source checksums
----------------
http://www.alglib.net/translator/re/alglib-3.8.2.cpp.tgz :
  CHECKSUM(SHA256) this package     : c02944558849c8b22f32f8dea03ebf3b77a0aab9aa2518927d25f6bfe7cb06a2
  CHECKSUM(SHA256) upstream package : c02944558849c8b22f32f8dea03ebf3b77a0aab9aa2518927d25f6bfe7cb06a2


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -m fedora-rawhide-i386 -b 1109490
Buildroot used: fedora-rawhide-i386
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 9 Sandro Mani 2014-06-18 20:40:11 UTC
Ups sorry, somehow misread the remark about the -doc License...

Spec URL: http://smani.fedorapeople.org/review/alglib.spec
SRPM URL: http://smani.fedorapeople.org/review/alglib-3.8.2-4.fc21.src.rpm

* Wed Jun 18 2014 Sandro Mani <manisandro@gmail.com> - 3.8.2-4
- Add missing license tag

Comment 10 Antonio Trande 2014-06-18 20:41:54 UTC
Package approved.

Comment 11 Sandro Mani 2014-06-18 20:44:34 UTC
Thanks a lot!

New Package SCM Request
=======================
Package Name: alglib
Short Description: A numerical analysis and data processing library
Owners: smani
Branches: f20
InitialCC:

Comment 12 Kevin Fenzi 2014-06-19 20:58:02 UTC
Git done (by process-git-requests).

Comment 13 Dave Love 2014-06-19 21:06:07 UTC
Could you use %setup instead of %autosetup in the spec and get it into EPEL?

Comment 14 Sandro Mani 2014-06-19 21:09:33 UTC
Package Change Request
======================
Package Name: alglib
New Branches: el6 epel7
Owners: smani
InitialCC:

Comment 15 Kevin Fenzi 2014-06-21 17:15:55 UTC
Git done (by process-git-requests).

Comment 16 Fedora Update System 2014-07-07 21:16:39 UTC
alglib-3.8.2-4.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/alglib-3.8.2-4.fc20

Comment 17 Fedora Update System 2014-07-09 02:30:38 UTC
alglib-3.8.2-4.fc20 has been pushed to the Fedora 20 testing repository.

Comment 18 Jakub Čajka 2014-07-09 09:53:41 UTC
Created attachment 916691 [details]
Exclusive for primary archs

Hello, 

package fails to build on secondary archs due to test failure. As upstream is not supporting any other archs then x86 and arm. I am suggesting to make this package exclusive for them. In attachment is patch doing so.

Best regards 
Jakub 

Links to failing builds:
http://s390.koji.fedoraproject.org/koji/taskinfo?taskID=1437085
http://ppc.koji.fedoraproject.org/koji/taskinfo?taskID=1938973
http://arm.koji.fedoraproject.org/koji/taskinfo?taskID=2482472

Comment 19 Sandro Mani 2014-07-09 09:56:43 UTC
Applied, thanks!

Comment 20 Fedora Update System 2014-07-09 11:00:11 UTC
alglib-3.8.2-5.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/alglib-3.8.2-5.fc20

Comment 21 Fedora Update System 2014-07-19 06:04:19 UTC
alglib-3.8.2-5.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 22 Fedora Update System 2015-01-02 13:25:56 UTC
alglib-3.9.0-1.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/alglib-3.9.0-1.el6

Comment 23 Fedora Update System 2015-01-02 13:26:28 UTC
alglib-3.9.0-1.el7 has been submitted as an update for Fedora EPEL 7.
https://admin.fedoraproject.org/updates/alglib-3.9.0-1.el7

Comment 24 Fedora Update System 2015-01-17 19:16:54 UTC
alglib-3.9.0-1.el7 has been pushed to the Fedora EPEL 7 stable repository.

Comment 25 Fedora Update System 2015-01-17 19:17:36 UTC
alglib-3.9.0-1.el6 has been pushed to the Fedora EPEL 6 stable repository.


Note You need to log in before you can comment on or make changes to this bug.